// FECHAS (COMIENZO)
function dateToday(){
  var fecha = new Date();
  var mes = fecha.getMonth()+1;
  var dia = fecha.getDate();
  var ano = fecha.getFullYear();
  if(dia<10)
    dia='0'+dia; //agrega cero si el menor de 10
  if(mes<10)
    mes='0'+mes; //agrega cero si el menor de 10
  var fechaAct=ano+"-"+mes+"-"+dia;
  return fechaAct;
}

function dateToYMD(date) {
  var d = date.getDate();
  var m = date.getMonth() + 1; //Month from 0 to 11
  var y = date.getFullYear();
  return '' + y + '-' + (m<=9 ? '0' + m : m) + '-' + (d <= 9 ? '0' + d : d);
}

function YMDToDate(date) {
  var dateParts = date.split("-");
  return new Date(dateParts[0], dateParts[1] - 1, dateParts[2].substr(0,2));
}

function YMDToDMY(date) {
  var dateParts = date.split("-");
  return dateParts[2]+'/'+dateParts[1]+'/'+dateParts[0];
}

function sumYMD(date, dPlus) {
  var fecha = YMDToDate(date); // Fecha actual
  fecha.setDate(fecha.getDate() + dPlus);
  return dateToYMD(fecha);
}
// FECHAS TERMINA

// RADIO BUTTON (COMIENZO)
function rdChecked(nombre, valor){
  $("#"+nombre+" > .btn").removeClass("active");
  $("#"+nombre+" > #"+valor).addClass("active");
}
// RADIO BUTTON (TERMINA)

// TABLAS (COMIENZO)
function tblSumCol(tabla, id) {
  var acum = 0;
  $("#"+tabla).find('tbody tr #'+id).each(function () {
    acum += parseFloat($(this).text());
  });
  return acum;
}

function tblToJson(titulos, tabla, checkbox){
  var arrayMulti = new Array();
  
  $("#"+tabla+" tbody tr").each(function(){
    var fila = {};
    $(this).find('td').each(function(i){
      if (i!=checkbox) {
        fila[titulos[i]] = $(this).text();
      }
    });
    arrayMulti.push(fila);
  });

  return JSON.stringify(arrayMulti);
}

function tblToJsonCb(titulos, tabla, checkbox){
  var arrayMulti = new Array();
  
  $("#"+tabla+" tbody tr").each(function(){
    var fila = {};
    $(this).find('td').each(function(i){
      if (i!=checkbox) {
        cb = ($(this).find('input[name="cb"]').is(":checked")) ? true : false;
        fila[titulos[i]] = (cb) ? "1" : $(this).text();
      }
    });
    arrayMulti.push(fila);
  });

  return JSON.stringify(arrayMulti);
}

function tblToJsonCbSkip(titulos, tabla, omitir, checkbox){
  var arrayMulti = new Array();
  
  $("#"+tabla+" tbody tr").each(function(){
    var fila = {};
    var cb = false;
    $(this).find('td').each(function(i){
      if (i!=omitir) {
        fila[titulos[i]] = (i != checkbox) ? $(this).text() : (cb = ($(this).find('input[name="cb"]').is(":checked")) ? true : false);
      }
    });
    if (cb) {
      arrayMulti.push(fila);
    }
  });

  return JSON.stringify(arrayMulti);
}

function tblClear(tabla, tfoot = false, tbody = true) {
  if (tfoot) { $("#"+tabla+" tfoot tr").remove() }
  if (tbody) { $("#"+tabla+" tbody tr").remove() }
}

function tblAllChecked(tabla, cbName, cbAll) {
  var $tdCheckboxChecked = [];
      $tdCheckboxChecked = $("#"+tabla).find('tbody input[name="'+cbName+'"]:checked');
  var $tdCheckbox = $("#"+tabla).find('tbody input[name="'+cbName+'"]');

  $("#"+cbAll).prop('checked', ($tdCheckboxChecked.length == $tdCheckbox.length));

  $("#"+tabla).find('tbody input[name="'+cbName+'"]').off('change');
  $("#"+tabla).find('tbody input[name="'+cbName+'"]').on('change', function(){
    $tdCheckboxChecked = $("#"+tabla).find('tbody input[name="'+cbName+'"]:checked');
    $("#"+cbAll).prop('checked', ($tdCheckboxChecked.length == $tdCheckbox.length));
  });
}

function cbAllChecked(tabla, cbName, cbAll) {
  $("#"+tabla).find('tbody input[name="'+cbName+'"]').prop('checked',  $("#"+cbAll).prop('checked'));
}
// TABLAS (TERMINA)

// IMAGENES (COMIENZA)
function imgSelect(inputFile, etiquetaImg, dirImg){
  const arrayArchivos = inputFile.files[0];
  const lectora  = new FileReader();

  if (!arrayArchivos.type.match('image.*')){
    etiquetaImg.src=dirImg;
    inputFile.value="";
    alert('El archivo seleccionado no es una imagen')
  }else{
    lectora.onloadend = function () {
      etiquetaImg.src = lectora.result;
    }

    lectora.onload = function (e) {
      //alert('cargando');
    }

    if (arrayArchivos!="") {
      lectora.readAsDataURL(arrayArchivos);
    } else {
      etiquetaImg.src = dirImg;
    }
  }
}

function imgExist(etiquetaImg, src, srcError) {
  var img = new Image();
  img.onload = function () {
    etiquetaImg.src=src;
  }
  img.onerror = function () {
    etiquetaImg.src=srcError;
  }
  img.src = src;
}
// IMAGENES (TERMINA)

// MOBILES (COMIENZA) 
function isMobile(){
  var ua = navigator.userAgent;
  var checker = {
    iphone: ua.match(/(iPhone|iPod|iPad)/),
    blackberry: ua.match(/BlackBerry/),
    android: ua.match(/Android/)
  };
  if (checker.android || checker.iphone || checker.blackberry){
    return true;
  } else {
    return false;
  }
}
// MOBILES (TERMINA)

// OBJETOS (COMIENZA)
function showValuesFormData(parametros){
  for(var pair of parametros.entries()) {
    console.log(pair[0]+ ', '+ pair[1]); 
  }
}
// OBJETOS  (TERMINA)

// PILL (COMIENZA)
function pillChange(current, next) {
  $("#"+current+"-tab").removeClass("active");
  $("#"+next+"-tab").addClass("active");
  $("#"+current).removeClass("show active");
  $("#"+next).addClass("show active");
}
// PILL (TERMINA)

// TEXT (COMIENZA)
var accent_map = {'á':'a', 'é':'e', 'è':'e', 'í':'i','ó':'o','ú':'u','Á':'a', 'É':'e', 'è':'e', 'Í':'i','Ó':'o','Ú':'u'};
function accent_fold (s) {
  if (!s) { return ''; }
  var ret = '';
  for (var i = 0; i < s.length; i++) {
    ret += accent_map[s.charAt(i)] || s.charAt(i);
  }
  return ret;
};

function isNullPer(val) {
  if (val == "" || val == null || val == 0) {
    return true;
  }
  return false;
}

function isNullNumber(val) {
  return (isNullPer(val)) ? 0 : parseFloat(val);
}

function numberInt(input, max, e) {
  /*var re = new RegExp("(^[\\d]{"+max+"})[\\d]", "g");
  input.value = input.value.replace(re, '$1');*/
  /*if(input.value.length==max) return false;
  return e.charCode >= 48 && e.charCode <= 57;*/
}

function numberDec(input, i, d) {
  /*var re = new RegExp("(\\d{0,"+i+"})[^.]*((?:\\.\\d{0,"+d+"})?)", "g");
  match = (re).exec(input.value.replace(/[^\d.]/g, ''));
  input.value = match[1] + match[2];*/
  /*if(input.value.length==i) return false;
  const keycode = e.keyCode || e.which;
  console.log(keycode)*/
  //return e.charCode >= 48 && e.charCode <= 57;
}


$('input[class*=dec]').change(function (e){
  const attrClass = $(this).attr('class').split(' ');
  var dec = attrClass.filter(function(el) {
      return el.toLowerCase().indexOf("dec-".toLowerCase()) > -1;
  });
  var d = dec.join().split('-');
  this.value = parseFloat(this.value).toFixed(d[1]);
});

$('input[class*=dec]').keyup(function (e){
  const keycode = e.keyCode || e.which;
  if ((keycode<48 && keycode>57)) return false;
});

$('input[class*=dec]').keypress(function (e){
  const keycode = e.keyCode || e.which;
  if (keycode==46) {
    if (this.value.includes('.')) return false;
  }
  /*var n = this.value.split('.');
  console.log(keycode, this.value, this.value.includes('.'), n[0], n[0].length, n[1]);

  console.log(keycode)*/

  //if ((keycode<48 && keycode>57)) return false;
  //if ((keycode>=48 && keycode==57) || keycode==46) {
    /*if (n[0].length>=i && keycode!=46) return false;
    if (keycode==46) {
      if (this.value.includes('.')) return false;
    }*/
  //}

  /*if (this.value.includes('.')) {
    //if (n[1].length>=d) return false;
  } else {
    if (n[0].length>=i && keycode!=46) return false;
  }*/
});
//onkeypress="numberDec(this, 14, 2);"

function numberFixedEmpty(n, d = 2) {
  return (n.toFixed(d)!=0) ? n.toFixed(d) : "";
}

function formatNumber(num, dec = 2) {
  return num.toFixed(dec).replace(/(\d)(?=(\d{3})+(?!\d))/g, '$1,')
}

function round(n, d = 2) {/*
  let r = 0.5 * Number.EPSILON * n;
  let o = 1; while(d-- > 0) o *= 10;
  if(n < 0)
      o *= -1;
  return Math.ceil((n + r) * o) / o;*/
  return Number(Math.round(n+'e'+(d.toString()))+'e-'+(d.toString()));
}
// TEXT (TERMINA)

// BLUR (COMIENZA)
function blurOn(input1, input2) {
  $(input1).blur(function (){
    if (isNullPer(input2.value)) {
      input1.value = "";
    }
  });
}
// BLUR (TERMINA)

const numberFormatGTQ = value =>
  new Intl.NumberFormat('en-US', {
    style: 'currency',
    currency: 'GTQ',
    minimumFractionDigits: 2
  }).format(value);
  
const numberFormatShortGTQ = value => numberFormatGTQ(value).replace('GTQ','Q');
  
const numberFormatNotSymbolGTQ = value => numberFormatGTQ(value).replace('GTQ','');

// NUMERO A LETRAS (COMIENZA)
// Primero funcion para poner 0 a la izquierda
function zfill(number, width) {
    var numberOutput = Math.abs(number); /* Valor absoluto del número */
    var length = number.toString().length; /* Largo del número */ 
    var zero = "0"; /* String de cero */  
    
    if (width <= length) {
        if (number < 0) {
             return ("-" + numberOutput.toString()); 
        } else {
             return numberOutput.toString(); 
        }
    } else {
        if (number < 0) {
            return ("-" + (zero.repeat(width - length)) + numberOutput.toString()); 
        } else {
            return ((zero.repeat(width - length)) + numberOutput.toString()); 
        }
    }
}

var numeroALetras = (function() {

// Código basado en https://gist.github.com/alfchee/e563340276f89b22042a
    function Unidades(num){

        switch(num)
        {
            case 1: return 'Un';
            case 2: return 'Dos';
            case 3: return 'Tres';
            case 4: return 'Cuatro';
            case 5: return 'Cinco';
            case 6: return 'Seis';
            case 7: return 'Siete';
            case 8: return 'Ocho';
            case 9: return 'Nueve';
        }

        return '';
    }//Unidades()

    function Decenas(num){

        let decena = Math.floor(num/10);
        let unidad = num - (decena * 10);

        switch(decena)
        {
            case 1:
                switch(unidad)
                {
                    case 0: return 'Diez';
                    case 1: return 'Once';
                    case 2: return 'Doce';
                    case 3: return 'Trece';
                    case 4: return 'Catorce';
                    case 5: return 'Quince';
                    default: return 'Dieci' + Unidades(unidad);
                }
            case 2:
                switch(unidad)
                {
                    case 0: return 'Veinte';
                    default: return 'Veinti' + Unidades(unidad);
                }
            case 3: return DecenasY('Treinta', unidad);
            case 4: return DecenasY('Cuarenta', unidad);
            case 5: return DecenasY('Cincuenta', unidad);
            case 6: return DecenasY('Sesenta', unidad);
            case 7: return DecenasY('Setenta', unidad);
            case 8: return DecenasY('Ochenta', unidad);
            case 9: return DecenasY('Noventa', unidad);
            case 0: return Unidades(unidad);
        }
    }//Unidades()

    function DecenasY(strSin, numUnidades) {
        if (numUnidades > 0)
            return strSin + ' y ' + Unidades(numUnidades)

        return strSin;
    }//DecenasY()

    function Centenas(num) {
        let centenas = Math.floor(num / 100);
        let decenas = num - (centenas * 100);

        switch(centenas)
        {
            case 1:
                if (decenas > 0)
                    return 'Ciento ' + Decenas(decenas);
                return 'Cien';
            case 2: return 'Doscientos ' + Decenas(decenas);
            case 3: return 'Trescientos ' + Decenas(decenas);
            case 4: return 'Cuatrocientos ' + Decenas(decenas);
            case 5: return 'Quinientos ' + Decenas(decenas);
            case 6: return 'Seiscientos ' + Decenas(decenas);
            case 7: return 'Setecientos ' + Decenas(decenas);
            case 8: return 'Ochocientos ' + Decenas(decenas);
            case 9: return 'Novecientos ' + Decenas(decenas);
        }

        return Decenas(decenas);
    }//Centenas()

    function Seccion(num, divisor, strSingular, strPlural) {
        let cientos = Math.floor(num / divisor)
        let resto = num - (cientos * divisor)

        let letras = '';

        if (cientos > 0)
            if (cientos > 1)
                letras = Centenas(cientos) + ' ' + strPlural;
            else
                letras = strSingular;

        if (resto > 0)
            letras += '';

        return letras;
    }//Seccion()

    function Miles(num) {
        let divisor = 1000;
        let cientos = Math.floor(num / divisor)
        let resto = num - (cientos * divisor)

        let strMiles = Seccion(num, divisor, 'un mil', 'mil');
        let strCentenas = Centenas(resto);

        if(strMiles == '')
            return strCentenas;

        return strMiles + ' ' + strCentenas;
    }//Miles()

    function Millones(num) {
        let divisor = 1000000;
        let cientos = Math.floor(num / divisor)
        let resto = num - (cientos * divisor)

        let strMillones = Seccion(num, divisor, 'un millon ', 'millones ');
        let strMiles = Miles(resto);

        if(strMillones == '')
            return strMiles;

        return strMillones + ' ' + strMiles;
    }//Millones()

    return function NumeroALetras(num, format = 1, currency = {}) {
      let data = {};
      switch (format){
        case 1:
          currency = currency || {};
          data = {
              numero: num,
              enteros: Math.floor(num),
              centavos: (((Math.round(num * 100)) - (Math.floor(num) * 100))),
              letrasCentavos: '',
              letrasMonedaPlural: currency.plural || 'Quetzales',//'PESOS', 'Dólares', 'Bolívares', 'etcs'
              letrasMonedaSingular: currency.singular || 'Quetzal', //'PESO', 'Dólar', 'Bolivar', 'etc'
              letrasMonedaCentavoPlural: currency.centPlural || 'Centavos',
              letrasMonedaCentavoSingular: currency.centSingular || 'Centavo'
          };

          if (data.centavos > 0) {
              data.letrasCentavos = 'con ' + (function () {
                      if (data.centavos == 1)
                          return Millones(data.centavos) + ' ' + data.letrasMonedaCentavoSingular;
                      else
                          return Millones(data.centavos) + ' ' + data.letrasMonedaCentavoPlural;
                  })();
          };

          if(data.enteros == 0)
              return 'Cero ' + data.letrasMonedaPlural + ' ' + data.letrasCentavos;
          if (data.enteros == 1)
              return Millones(data.enteros) + ' ' + data.letrasMonedaSingular + ' ' + data.letrasCentavos;
          else
              return Millones(data.enteros) + ' ' + data.letrasMonedaPlural + ' ' + data.letrasCentavos;
          break;

        case 2:
          currency = currency || {};
          data = {
              numero: num,
              enteros: Math.floor(num),
              centavos: (((Math.round(num * 100)) - (Math.floor(num) * 100))),
              letrasCentavos: '',
              letrasMonedaPlural: currency.plural || '',//'PESOS', 'Dólares', 'Bolívares', 'etcs'
              letrasMonedaSingular: currency.singular || '', //'PESO', 'Dólar', 'Bolivar', 'etc'
              letrasMonedaCentavoPlural: currency.centPlural || '',
              letrasMonedaCentavoSingular: currency.centSingular || ''
          };

          if (data.centavos > 0) {
              //
              data.letrasCentavos = 'con ' + zfill(data.centavos, 2) + '/100';
          } else {
              data.letrasCentavos = 'con 00/100';
          };

          if(data.enteros == 0)
              return 'Cero ' + data.letrasCentavos;
          else
              return Millones(data.enteros) + ' ' + data.letrasCentavos;
          break;
      }
    };

})();

// USO:
/*numeroALetras(500.34, 1, {
  plural: 'dólares estadounidenses',
  singular: 'dólar estadounidense',
  centPlural: 'centavos',
  centSingular: 'centavo'
})*/
// NUMERO A LETRAS (TERMINA)

// UTF8 (EMPIEZA)
function encode_utf8(s) {
  return unescape(encodeURIComponent(s));
}

function decode_utf8(s) {
  return decodeURIComponent(escape(s));
}
// UTF8 (TERMINA)