<?php
/*
Códigos de error MySQL:
1062 : Duplicado
*/
require_once('../conexion/dbConstantes.php');

class dbExec extends dbConstantes
{
	var $classQuery;
	var $conn;
	
	var $errno = '';
	var $error = '';

	function __construct($dbNum = 1) {
		$c = DbConstantes::getConstantes();
		switch ($dbNum) {
			case 1:
				$this->conn = new mysqli($c['servidor'], $c['usuario'], $c['contrasena'], $c['nombredb'][1]);
				break;
			
			default:
				$this->conn = new mysqli($c['servidor'], $c['usuario'], $c['contrasena'], $c['nombredb'][2]);
				break;
		}
		mysqli_set_charset($this->conn, "latin1");
	}

	public function rSuccess($titulo) {
		return array(
		  'error'=>false,
		  'msg'=>array(
		    'type'=>'success',
		    'title'=>$titulo,
		    'showConfirmButton'=>false,
		    'timer'=>1250,
		  ),
		);
	}

	private function rError() {
		return array(
			'errno'=>$this->conn->errno,
			'error'=>true,
			'msg'=>array(
			    'type'=>'error',
			    'title'=>'Error '.$this->conn->errno,
		  		'text'=>$this->conn->error,
		    	'ok'=>'Aceptar',
		    	'timer'=>1250,
		  ),
		);
	}

	public function rErrorPublic($errnoPublic, $errorPublic) {
		return array(
			'errno'=>''.$errnoPublic,
			'error'=>true,
			'msg'=>array(
			    'type'=>'error',
			    'title'=>'Error '.$errnoPublic,
		  		'text'=>''.$errorPublic,
		    	'ok'=>'Aceptar',
		    	'timer'=>1250,
		  ),
		);
	}

	public function rSuccessPublic($titulo, $text) {
		return array(
		  'error'=>false,
		  'msg'=>array(
		    'type'=>'success',
		    'title'=>$titulo,
		    'text'=>$text,
		    'ok'=>'Aceptar',
		  ),
		);
	}

	// INSERTAR (INSERT) Y MODIFICAR (UPDATE) CON EXCEPCION
	function iuEx($qri, $qru){
		if ($this->conn->query($qri) === TRUE) {
		  $r = dbExec::rSuccess("Se guardó correctamente");
		  $r['errno'] = 0;
		} else {
			if ($this->conn->errno == dbExec::errnoDuplicate()) {
				if ($this->conn->query($qru) === TRUE) {
				  $r = dbExec::rSuccess("Se guardó correctamente");
				  $r['errno']=dbExec::errnoDuplicate();
				} else {
					$r = dbExec::rError();
				}
			} else {
				$r = dbExec::rError();
			}
		}
		return $r;
	}

	// INSERTAR (INSERT) CON EXCEPCION
	function iEx($qr){
		if ($this->conn->query($qr) === TRUE) {
		  $r = dbExec::rSuccess("Se guardó correctamente");
		} else {
			$r = dbExec::rError();
		}
		return $r;
	}

	// MODIFICACION (UPDATE) CON EXCEPCION
	function uEx($qr){
		if ($this->conn->query($qr) === TRUE) {
		  $r = dbExec::rSuccess("Se guardó correctamente");
		} else {
			$r = dbExec::rError();
		}
		return $r;
	}

	// CONSULTA (SELECT) CON EXCEPCION
	function sEx($qr, $nomArray){
		$s = $this->conn->query($qr);
		if ($s === FALSE) {
			$r = dbExec::rError();
		} else {
			$r = array(
				'error'=>false,
			);
			$r[$nomArray]=$s->fetch_assoc();
		}
		return $r;
	}

	// ELIMINACION (DELETE) CON EXCEPCION
	function dEx($qr){
		if ($this->conn->query($qr) === TRUE) {
		  $r = dbExec::rSuccess("Se eliminó correctamente");
		} else {
			$r = dbExec::rError();
		}
		return $r;
	}
	
	// ANULACION (UPDATE) CON EXCEPCION
	function anEx($qr){
		if ($this->conn->query($qr) === TRUE) {
		  $r = dbExec::rSuccess("Se anuló correctamente");
		} else {
			$r = dbExec::rError();
		}
		return $r;
	}

	// CONSULTA CON RESPUESTA "FETCH_ALL" (SE USA PARA TABLE O GRID)
	function sFetchAll($qr){
		$s = $this->conn->query($qr);
		return dbExec::fetchAll($s);
	}

	function sFetchAssoc($qr){
		$s = $this->conn->query($qr);
		return dbExec::fetchAssoc($s);
	}

	function dataSeek($result, $n) {
        return $result->data_seek($n);
    }

	function query($query) {
		$this->classQuery = $query;
		return $this->conn->query($query);
	}

	function multiQuery($query) {
		$this->classQuery = $query;
		return $this->conn->multi_query($query);
	}

	function multiQueryIEx($query) {
		if (dbExec::multiQuery($query) === TRUE) {
		  $r = dbExec::rSuccess("Se guardó correctamente");
		} else {
			$r = dbExec::rError();
		}
		return $r;
	}
	
	function escapeString($query) {
		return $this->conn->escape_string($query);
	}
	
	function numRows($result) {
		return $result->num_rows;
	}
	
	function lastInsertedID() {
		return $this->conn->insert_id;
	}
	
	function fetchAssoc($result) {
		return $result->fetch_assoc();
	}
	
	function fetchArray($result , $resultType = MYSQLI_ASSOC) {
		return $result->fetch_array($resultType);
	}
	
	function fetchAll($result , $resultType = MYSQLI_ASSOC) {
		return $result->fetch_all($resultType);
	}
	
	function fetchRow($result) {
		return $result->fetch_row();
	}
	
	function freeResult($result) {
		return $this->conn->free($result);
	}
	
	function close() {
//		$this->conn->close();
		mysqli_close($this->conn);
//		mysqli_close(mysqli $this->conn): bool		
	}
	
	function sql_error() {
		if(empty($error)) {
			$errno = $this->conn->errno;
			$error = $this->conn->error;
		}
		return $errno . ' : ' . $error;
	}
	
	function errno() {
		return $this->conn->errno;
	}
	
	function error() {
		return $this->conn->error;
	}

	function errnoDuplicate() {
		return 1062;
	}

	function recUpdate($err) {
		if ($err === dbExec::errnoDuplicate()) {
			return true;
		}
		return false;
	}






	// LA EJECICIÓN DEL MULTIQUERY AVISA EN DONDE HUBO ERROR SI HAY, SINO DEVUELVE JSON OK
	function storeResult() {
		return $this->conn->store_result();
	}

	function moreResults() {
		return $this->conn->more_results();
	}

	function nextResult() {
		return $this->conn->next_result();
	}

	function multiQueryExR($query) {
		if (dbExec::multiQuery($query)) {
			do {
				$result=dbExec::storeResult();
			} while(dbExec::moreResults() && dbExec::nextResult());
		}

		if($error_mess=dbExec::error()){
			$r = dbExec::rError();
		} else {
			$r = dbExec::rSuccess("Se guardó correctamente");
		}
		return $r;
	}

	function multiQueryAnEx($query) {
		if (dbExec::multiQuery($query)) {
			do {
				$result=dbExec::storeResult();
			} while(dbExec::moreResults() && dbExec::nextResult());
		}

		if($error_mess=dbExec::error()){
			$r = dbExec::rError();
		} else {
			$r = dbExec::rSuccess("Se anuló correctamente");
		}
		return $r;
	}

	function multiQueryDEx($query) {
		if (dbExec::multiQuery($query)) {
			do {
				$result=dbExec::storeResult();
			} while(dbExec::moreResults() && dbExec::nextResult());
		}

		if($error_mess=dbExec::error()){
			$r = dbExec::rError();
		} else {
			$r = dbExec::rSuccess("Se borró correctamente");
		}
		return $r;
	}
}
?>