<?php
/*
Códigos de error MySQL:
1062 : Duplicado
*/
require_once('../conexion/dbConstantesAMT.php');

class dbExecAMT extends dbConstantesAMT
{
	var $classQueryamt;
	var $connamt;
	
	var $errnoamt = '';
	var $erroramt = '';

	function __construct($dbNumamt = 1) {
		$camt = DbConstantesamt::getConstantesamt();
		switch ($dbNumamt) {
			case 1:
				$this->connamt = new mysqli($camt['servidor'], $camt['usuario'], $camt['contrasena'], $camt['nombredb'][1]);
				break;
			
			default:
				$this->connamt = new mysqli($camt['servidor'], $camt['usuario'], $camt['contrasena'], $camt['nombredb'][2]);
				break;
		}
		mysqli_set_charset($this->connamt, "latin1");
	}

	public function rSuccessamt($titulo) {
		return array(
		  'error'=>false,
		  'msg'=>array(
		    'type'=>'success',
		    'title'=>$titulo,
		    'showConfirmButton'=>false,
		    'timer'=>1250,
		  ),
		);
	}

	private function rErroramt() {
		return array(
			'errno'=>$this->connamt->errnoamt,
			'error'=>true,
			'msg'=>array(
			    'type'=>'error',
			    'title'=>'Error '.$this->connamt->errnoamt,
		  		'text'=>$this->connamt->erroramt,
		    	'ok'=>'Aceptar',
		    	'timer'=>1250,
		  ),
		);
	}

	public function rErrorPublicamt($errnoPublic, $errorPublic) {
		return array(
			'errno'=>''.$errnoPublic,
			'error'=>true,
			'msg'=>array(
			    'type'=>'error',
			    'title'=>'Error '.$errnoPublic,
		  		'text'=>''.$errorPublic,
		    	'ok'=>'Aceptar',
		    	'timer'=>1250,
		  ),
		);
	}

	public function rSuccessPublicamt($titulo, $text) {
		return array(
		  'error'=>false,
		  'msg'=>array(
		    'type'=>'success',
		    'title'=>$titulo,
		    'text'=>$text,
		    'ok'=>'Aceptar',
		  ),
		);
	}

	// INSERTAR (INSERT) Y MODIFICAR (UPDATE) CON EXCEPCION
	function iuExamt($qri, $qru){
		if ($this->connamt->queryamt($qri) === TRUE) {
		  $r = dbExecamt::rSuccessamt("Se guardó correctamente");
		  $r['errnoamt'] = 0;
		} else {
			if ($this->connamt->errnoamt == dbExecAMT::errnoDuplicate()) {
				if ($this->connamt->queryamt($qru) === TRUE) {
				  $r = dbExecAMT::rSuccessamt("Se guardó correctamente");
				  $r['errnoamt']=dbExecAMT::errnoDuplicateamt();
				} else {
					$r = dbExecAMT::rErroramt();
				}
			} else {
				$r = dbExecAMT::rErroramt();
			}
		}
		return $r;
	}

	// INSERTAR (INSERT) CON EXCEPCION
	function iExamt($qr){
		if ($this->connamt->queryamt($qr) === TRUE) {
		  $r = dbExecAMT::rSuccessamt("Se guardó correctamente");
		} else {
			$r = dbExecAMT::rErroramt();
		}
		return $r;
	}

	// MODIFICACION (UPDATE) CON EXCEPCION
	function uExamt($qr){
		if ($this->connamt->queryamt($qr) === TRUE) {
		  $r = dbExecAMT::rSuccessamt("Se guardó correctamente");
		} else {
			$r = dbExecAMT::rError();
		}
		return $r;
	}

	// CONSULTA (SELECT) CON EXCEPCION
	function sExamt($qr, $nomArray){
		$s = $this->connamt->queryamt($qr);
		if ($s === FALSE) {
			$r = dbExecAMT::rErroramt();
		} else {
			$r = array(
				'error'=>false,
			);
			$r[$nomArray]=$s->fetch_assocamt();
		}
		return $r;
	}

	// ELIMINACION (DELETE) CON EXCEPCION
	function dExamt($qr){
		if ($this->connamt->queryamt($qr) === TRUE) {
		  $r = dbExecAMT::rSuccessamt("Se eliminó correctamente");
		} else {
			$r = dbExecAMT::rErroramt();
		}
		return $r;
	}
	
	// ANULACION (UPDATE) CON EXCEPCION
	function anExamt($qr){
		if ($this->connamt->queryamt($qr) === TRUE) {
		  $r = dbExecAMT::rSuccessamt("Se anuló correctamente");
		} else {
			$r = dbExecAMT::rErroramt();
		}
		return $r;
	}

	// CONSULTA CON RESPUESTA "FETCH_ALL" (SE USA PARA TABLE O GRID)
	function sFetchAllamt($qr){
		$s = $this->connamt->queryamt($qr);
		return dbExecAMT::fetchAllamt($s);
	}

	function sFetchAssocamt($qr){
		$s = $this->connamt->queryamt($qr);
		return dbExecAMT::fetchAssocamt($s);
	}

	function dataSeekamt($result, $n) {
        return $result->data_seekamt($n);
    }

	function queryamt($query) {
		$this->classQuery = $query;
		return $this->connamt->query($query);
	}

	function multiQueryamt($query) {
		$this->classQuery = $query;
		return $this->connamt->multi_queryamt($query);
	}

	function multiQueryIExamt($query) {
		if (dbExecAMT::multiQueryamt($query) === TRUE) {
		  $r = dbExecAMT::rSuccessamt("Se guardó correctamente");
		} else {
			$r = dbExecAMT::rErroramt();
		}
		return $r;
	}
	
	function escapeStringamt($query) {
		return $this->connamt->escape_stringamt($query);
	}
	
	function numRowsamt($result) {
		return $result->num_rows;
	}
	
	function lastInsertedIDamt() {
		return $this->connamt->insert_id;
	}
	
	function fetchAssocamt($result) {
		return $result->fetch_assoc();
	}
	
	function fetchArrayamt($result , $resultType = MYSQLI_ASSOC) {
		return $result->fetch_array($resultType);
	}
	
	function fetchAllamt($result , $resultType = MYSQLI_ASSOC) {
		return $result->fetch_all($resultType);
	}
	
	function fetchRowamt($result) {
		return $result->fetch_row();
	}
	
	function freeResultamt($result) {
		return $this->connamt->free($result);
	}
	
	function closeamt() {
//		$this->conn->close();
		mysqli_close($this->connamt);
//		mysqli_close(mysqli $this->conn): bool		
	}
	
	function sql_erroramt() {
		if(empty($error)) {
			$errnoamt = $this->connamt->errnoamt;
			$erroramt = $this->connamt->erroramt;
		}
		return $errnoamt . ' : ' . $erroramt;
	}
	
	function errnoamt() {
		return $this->connamt->errnoamt;
	}
	
	function erroramt() {
		return $this->connamt->erroramt;
	}

	function errnoDuplicateamt() {
		return 1062;
	}

	function recUpdateamt($err) {
		if ($err === dbExecAMT::errnoDuplicateamt()) {
			return true;
		}
		return false;
	}






	// LA EJECICIÓN DEL MULTIQUERY AVISA EN DONDE HUBO ERROR SI HAY, SINO DEVUELVE JSON OK
	function storeResultamt() {
		return $this->connamt->store_result();
	}

	function moreResultsamt() {
		return $this->connamt->more_results();
	}

	function nextResultamt() {
		return $this->connamt->next_result();
	}

	function multiQueryExRamt($query) {
		if (dbExecAMT::multiQueryamt($query)) {
			do {
				$result=dbExecAMT::storeResultamt();
			} while(dbExecAMT::moreResultsamt() && dbExecAMT::nextResultamt());
		}

		if($error_mess=dbExecAMT::erroramt()){
			$r = dbExecAMT::rErroramt();
		} else {
			$r = dbExecAMT::rSuccessamt("Se guardó correctamente");
		}
		return $r;
	}

	function multiQueryAnExamt($query) {
		if (dbExecAMT::multiQueryamt($query)) {
			do {
				$result=dbExecAMT::storeResultamt();
			} while(dbExecAMT::moreResultsamt() && dbExecAMT::nextResultamt());
		}

		if($error_mess=dbExecAMT::erroramt()){
			$r = dbExecAMT::rErroramt();
		} else {
			$r = dbExecAMT::rSuccessamt("Se anuló correctamente");
		}
		return $r;
	}

	function multiQueryDExamt($query) {
		if (dbExecAMT::multiQueryamt($query)) {
			do {
				$result=dbExecAMT::storeResultamt();
			} while(dbExecAMT::moreResultsamt() && dbExecAMT::nextResultamt());
		}

		if($error_mess=dbExecAMT::erroramt()){
			$r = dbExecAMT::rErroramt();
		} else {
			$r = dbExecAMT::rSuccessamt("Se borró correctamente");
		}
		return $r;
	}
}
?>